KLed class Reference (kdeui Library)

| # kdeui Library API Documentation
Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Source Files

# KLed Class Reference

Displays a round or rectangular light emitting diode. An LED widget. More...

`#include <kled.h>`

Inheritance diagram for KLed:

[legend]
Collaboration diagram for KLed:

[legend]
List of all members.

## Public Types
enum | State { Off, On }
| Status of the light is on/off. LED on/off. More...
enum | Shape { Rectangular, Circular }
| Shades of the lamp. LED shape. More...
enum | Look { Flat, Raised, Sunken }
| Displays a flat, round or sunken LED. LED look. More...
## Public Slots
void | toggle ()
| Toggles the state of the led from Off to On or vice versa.
void | on ()
| Sets the state of the widget to On.
void | off ()
| Sets the state of the widget to Off.
## Public Member Functions
| KLed (QWidget *parent=0, const char *name=0)
| Constructs a green, round LED widget which will initially be turned on.
| KLed (const QColor &col=Qt::green, QWidget *parent=0, const char *name=0)
| Constructor with the ledcolor, the parent widget, and the name. Constructor.
| KLed (const QColor &col, KLed::State st, KLed::Look look, KLed::Shape shape, QWidget *parent=0, const char *name=0)
| Constructor with the ledcolor, ledstate, ledlook, the parent widget, and the name. Constructor.
| ~KLed ()
| Destructor Destructor.
State | state () const
| Returns the current state of the widget (on/off). Returns LED state.
Shape | shape () const
QColor | color () const
| Returns the color of the widget Returns LED color.
Look | look () const
| Returns the look of the widget. Returns LED look.
int | darkFactor () const
| Returns the factor to darken the LED. Returns dark factor.
void | setState (State state)
| Sets the state of the widget to On or Off. Set LED state.
void | setShape (Shape s)
| Set the shape of the LED to `s`.
void | toggleState ()
| Toggle the state of the LED from Off to On and vice versa. Toggles LED on->off / off->on. This class or method is obsolete, it is provided for compatibility only., use toggle() instead.
void | setColor (const QColor &color)
| Set the color of the widget. Sets the LED color.
void | setDarkFactor (int darkfactor)
| Sets the factor to darken the LED in OFF state. sets the factor to darken the LED.
void | setLook (Look look)
| Sets the look of the widget. Sets LED look.
virtual QSize | sizeHint () const
virtual QSize | minimumSizeHint () const
## Protected Member Functions
virtual void | paintFlat ()
| Paints a circular, flat LED.
virtual void | paintRound ()
| Paints a circular, raised LED.
virtual void | paintSunken ()
| Paints a circular, sunken LED.
virtual void | paintRect ()
| Paints a rectangular, flat LED.
virtual void | paintRectFrame (bool raised)
| Paints a rectangular LED, either raised or sunken, depending on its argument.
void | paintEvent (QPaintEvent *)
virtual void | virtual_hook (int id, void *data)

## Detailed Description

Displays a round or rectangular light emitting diode. An LED widget.

It is configurable to five colors, the two on/off states and three styles (or "looks");

It may display itself in a performant flat view, a round view with light spot or a round view sunken in the screen.

Author:
  Joerg Habenicht, Richard J. Moore (rich@kde.org) 1998, 1999

Definition at line 41 of file kled.h.

## Member Enumeration Documentation

enum KLed::State

| Status of the light is on/off. LED on/off. Definition at line 57 of file kled.h.

enum KLed::Shape

| Shades of the lamp. LED shape. Definition at line 63 of file kled.h.

enum KLed::Look

| Displays a flat, round or sunken LED. LED look. Displaying the LED flat is less time and color consuming, but not so nice to see. The sunken LED itself is (certainly) smaller than the round LED because of the 3 shading circles and is most time consuming. Makes sense for LED > 15x15 pixels. Timings: ( AMD K5/133, Diamond Stealth 64 PCI Graphics, widgetsize 29x29 ) flat Approximately 0.7 msec per paint round Approximately 2.9 msec per paint sunken Approximately 3.3 msec per paint The widget will be updated on the next repaining event. Definition at line 85 of file kled.h.

## Constructor & Destructor Documentation

KLed::KLed | ( | QWidget * | parent = 0,
|  | const char * | name = 0
| ) |

| Constructs a green, round LED widget which will initially be turned on. Definition at line 134 of file kled.cpp. References QColor::dark(), KStdAccel::name(), and setColor().

KLed::KLed | ( | const QColor & | col = Qt::green,
|  | QWidget * | parent = 0,
|  | const char * | name = 0
| ) |

  | Constructor with the ledcolor, the parent widget, and the name. Constructor. The State will be defaulted On and the Look round. Parameters:
  ledcolor | Initial color of the LED.
  parent | Will be handed over to QWidget.
  name | Will be handed over to QWidget.
Definition at line 149 of file kled.cpp. References QColor::dark(), KStdAccel::name(), and setColor().

KLed::KLed | ( | const QColor & | col,
|  | KLed::State | st,
|  | KLed::Look | look,
|  | KLed::Shape | shape,
|  | QWidget * | parent = 0,
|  | const char * | name = 0
| ) |

  | Constructor with the ledcolor, ledstate, ledlook, the parent widget, and the name. Constructor. Differs from above only in the parameters, which configure all settings. Parameters:
  ledcolor | Initial color of the LED.
  state | Sets the State.
  look | Sets the Look.
  parent | Will be handed over to QWidget.
  name | Will be handed over to QWidget.
Definition at line 163 of file kled.cpp. References QColor::dark(), KStdAccel::name(), and setColor().

KLed::~KLed | ( |  | ) |

| Destructor Destructor. Definition at line 179 of file kled.cpp.

## Member Function Documentation

KLed::State KLed::state | ( |  | ) | const

| Returns the current state of the widget (on/off). Returns LED state. See also: State Definition at line 540 of file kled.cpp.

QColor KLed::color | ( |  | ) | const

| Returns the color of the widget Returns LED color. See also: Color Definition at line 552 of file kled.cpp. Referenced by paintFlat(), paintRound(), and paintSunken().

KLed::Look KLed::look | ( |  | ) | const

| Returns the look of the widget. Returns LED look. See also: Look Definition at line 558 of file kled.cpp.

int KLed::darkFactor | ( |  | ) | const

| Returns the factor to darken the LED. Returns dark factor. See also: setDarkFactor() Definition at line 612 of file kled.cpp.

void KLed::setState | ( | State | state | ) |

  | Sets the state of the widget to On or Off. Set LED state. The widget will be painted immediately. See also: on() off() toggle() toggleState() Parameters:
  state | The LED state: on or off.
Definition at line 564 of file kled.cpp. References QWidget::update(). Referenced by off(), and on().

void KLed::setShape | ( | Shape | s | ) |

| Set the shape of the LED to `s`. Definition at line 582 of file kled.cpp. References QWidget::update().

void KLed::toggleState | ( |  | ) |

| Toggle the state of the LED from Off to On and vice versa. Toggles LED on->off / off->on. This class or method is obsolete, it is provided for compatibility only., use toggle() instead. The widget will be repainted when returning to the main event loop. Definition at line 574 of file kled.cpp. References QWidget::update(). Referenced by toggle().

void KLed::setColor | ( | const QColor & | color | ) |

  | Set the color of the widget. Sets the LED color. The Color is shown with the KLed::On state. The KLed::Off state is shown with QColor.dark() method The widget calls the update() method, so it will be updated when entering the main event loop. See also: Color Parameters:
  color | New color of the LED.
Definition at line 592 of file kled.cpp. References QWidget::update(). Referenced by KLed().

void KLed::setDarkFactor | ( | int | darkfactor | ) |

  | Sets the factor to darken the LED in OFF state. sets the factor to darken the LED. Same as QColor::dark(). "darkfactor should be greater than 100, else the LED gets lighter in OFF state. Defaults to 300. See also: QColor Parameters:
  darkfactor | sets the factor to darken the LED.
Definition at line 602 of file kled.cpp. References QColor::dark(), and QWidget::update().

void KLed::setLook | ( | Look | look | ) |

  | Sets the look of the widget. Sets LED look. The look may be flat, round or sunken. The widget calls the update() method, so it will be updated when entering the main event loop. See also: Look Parameters:
  look | New look of the LED.
Definition at line 618 of file kled.cpp. References QWidget::update().

void KLed::toggle | ( |  | ) | `[slot]`

| Toggles the state of the led from Off to On or vice versa. The widget repaints itself immediately. Definition at line 628 of file kled.cpp. References toggleState().

void KLed::on | ( |  | ) | `[slot]`

| Sets the state of the widget to On. The widget will be painted immediately. See also: off() toggle() toggleState() setState() Definition at line 634 of file kled.cpp. References setState().

void KLed::off | ( |  | ) | `[slot]`

| Sets the state of the widget to Off. The widget will be painted immediately. See also: on() toggle() toggleState() setState() Definition at line 640 of file kled.cpp. References setState().

void KLed::paintFlat | ( |  | ) | `[protected, virtual]`

| Paints a circular, flat LED. Definition at line 239 of file kled.cpp. References QPainter::begin(), color(), QPainter::drawEllipse(), QPainter::end(), QWidget::height(), QPainter::setBrush(), QPen::setColor(), QBrush::setColor(), QPainter::setPen(), QColor::setRgb(), QBrush::setStyle(), QPen::setWidth(), and QWidget::width().

void KLed::paintRound | ( |  | ) | `[protected, virtual]`

| Paints a circular, raised LED. Definition at line 285 of file kled.cpp. References QPainter::begin(), color(), QPainter::drawEllipse(), QPainter::end(), QWidget::height(), QColor::light(), QWidget::pos(), QPainter::setBrush(), QPen::setColor(), QBrush::setColor(), QPainter::setPen(), QColor::setRgb(), QBrush::setStyle(), QPen::setWidth(), and QWidget::width().

void KLed::paintSunken | ( |  | ) | `[protected, virtual]`

| Paints a circular, sunken LED. Definition at line 370 of file kled.cpp. References QPainter::begin(), color(), QPainter::drawArc(), QPainter::drawEllipse(), QPainter::end(), QWidget::height(), QColor::light(), QWidget::pos(), QPainter::setBrush(), QPen::setColor(), QBrush::setColor(), QPainter::setPen(), QColor::setRgb(), QBrush::setStyle(), QPen::setWidth(), and QWidget::width().

void KLed::paintRect | ( |  | ) | `[protected, virtual]`

| Paints a rectangular, flat LED. Definition at line 477 of file kled.cpp. References QColor::dark(), QPainter::drawLine(), QPainter::drawRect(), QWidget::height(), QPainter::setBrush(), QPainter::setPen(), and QWidget::width().

void KLed::paintRectFrame | ( | bool | raised | ) | `[protected, virtual]`

| Paints a rectangular LED, either raised or sunken, depending on its argument. Definition at line 508 of file kled.cpp. References QPainter::drawLine(), QPainter::drawRect(), QPainter::fillRect(), QWidget::height(), QPainter::setPen(), and QWidget::width().

The documentation for this class was generated from the following files:

- kled.h
- kled.cpp

This file is part of the documentation for kdelibs Version 3.1.5.
Documentation copyright © 1996-2002 the KDE developers.
Generated on Wed Jan 28 13:01:51 2004 by doxygen 1.3.4 written by Dimitri van Heesch, © 1997-2001